/* eslint react/no-danger: 0 */
import React from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import Modal from 'react-modal';

class ColbyModal extends React.Component {
  static propTypes = {
    label: PropTypes.string,
    modalContent: PropTypes.string.isRequired,
  };

  static defaultProps = {
    label: 'Open Modal',
  };

  constructor(props) {
    super(props);

    this.state = {
      isOpen: false,
    };
  }

  render() {
    return (
      <Modal
        isOpen={this.state.isOpen}
        onRequestClose={() => this.setState({ isOpen: false })}
        contentLabel={this.props.label}
      >
        <div
          dangerouslySetInnerHTML={{
            __html: this.props.modalContent,
          }}
        />
      </Modal>
    );
  }
}

const init = () => {
  Array.prototype.forEach.call(
    document.querySelectorAll('[data-modal]'),
    (container) => {
      container.addEventListener('click', (event) => {
        event.preventDefault();

        ReactDOM.render(<ColbyModal {...container.dataset} />, container);
      });
    }
  );
};

const initPostModals = () => {
  Array.prototype.forEach.call(
    document.querySelectorAll('.post a'),
    (container) => {
      const img = container.querySelector('img');

      if (!img) {
        return;
      }

      container.addEventListener('click', (event) => {
        event.preventDefault();

        ReactDOM.render(
          <ColbyModal label="Open Image" modalContent={img} />,
          container
        );
      });
    }
  );
};

window.addEventListener('load', init);
window.addEventListener('load', initPostModals);
