<?php

function render_big_panel( $atts, $content ) {
	if ( ! $atts['img-id'] ) {
		return '';
	}

	$image = wp_get_attachment_image_src( $atts['img-id'], empty( $atts['size'] ) ? 'large' : $atts['size'] );

	$content = apply_filters( 'the_content', $content );
	$extra_class = $atts['extra-class'] ? " {$atts['extra-class']}" : '';
	$link = $atts['link'] ? " href=\"{$atts['link']}\"" : '';
	$tag = $link ? 'a' : 'div';

	return "
		<$tag$link class=\"bigPanel$extra_class\" style=\"background-image: url('$image[0]');\">
		  <div class=\"absolute-flush\">
		  	<div class=\"contentContainer\">
			  	$content
			</div>
		  </div>
		</$tag>
	";
}

function init_big_panel() {
	add_shortcode( 'big-panel', 'render_big_panel' );
}

add_action( 'init', 'init_big_panel' );
